#include "node.h"
#include <iostream>


/*
    @brief construtor de Node usando template
    @return   Node<T>
*/
template<typename T>
Node<T>::Node(void):
count(0), next(NULL), prev(NULL) {}

/*
    @brief Construtor  parametrizado de Node usando template
    @param val - valor do nó
    @return  Node<T>
*/
template<typename T>
Node<T>::Node(T val):
value(val), count(0), next(NULL), prev(NULL) {}

/*
    @brief construtor do Objeto (passando parametros) de Node com template
    @param val - valor do nó
            n - ponteiro para um nó
            p - ponteiro para um nó
    @return  Node<T>
*/
template<typename T>
Node<T>::Node(T val, Node* n, Node* p):
value(val), next(n), prev(p) {}


/*
    @brief Get da variavel Value usando template
    @return  valor do nó
*/
template<typename T>
T Node<T>::getValue(void)
{
    return this->value;
}

/*
    brief Get da variavel Next usando template
    @return  ponteiro para o próximo nó
*/
template<typename T>
Node<T>* Node<T>::getNext(void)
{
    return this->next;
}

/*
    brief Set da variavel Next usando template
    @param n - Proximo nó
*/
template<typename T>
void Node<T>::setNext(Node<T>* n)
{
    this->next = n;
}

/*
    @brief Get da variavel Preivous usando template
    @return ponteiro para o nó anterior
*/
template<typename T>
Node<T>* Node<T>::getPrevious(void)
{
	return this->prev;
}

/*
    @brief Set da variavel Previous usando template
    @param p - Nó anterior
*/
template<typename T>
void Node<T>::setPrevious(Node<T>* p)
{
	this->prev = p;
}
/*
    @brief Get da variavel Count usando template
    @return valor do contador do nó
*/

template<typename T>
int Node<T>::getCount()
{
	return this->count;
}

/*
    @brief Set da variavel Count usando template
    @param c - valor a ser incrementado no count
*/
template<typename T>
void Node<T>::setCount(int c)
{
	this->count = c;
}
